
Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
        Dim keys As List(Of String) = Request.Form.AllKeys.Where(Function(key) key.Contains("txtDynamic")).ToList()
        Dim i As Integer = 1
        For Each key As String In keys
            Me.CreateTextBox("txtDynamic" & i)
            i += 1
        Next
    End Sub

    Protected Sub AddTextBox(sender As Object, e As EventArgs)
        Dim index As Integer = pnlTextBoxes.Controls.OfType(Of TextBox)().ToList().Count + 1
        Me.CreateTextBox("txtDynamic" & index)
    End Sub

    Private Sub CreateTextBox(id As String)
        Dim txt As New TextBox()
        txt.ID = id
        pnlTextBoxes.Controls.Add(txt)

        Dim lt As New Literal()
        lt.Text = "<br />"
        pnlTextBoxes.Controls.Add(lt)
    End Sub

    Protected Sub GetTextBoxValues(sender As Object, e As EventArgs)
        Dim message As String = ""
        For Each textBox As TextBox In pnlTextBoxes.Controls.OfType(Of TextBox)()
            message += textBox.ID + ": " + textBox.Text + "\n"
        Next
        ClientScript.RegisterClientScriptBlock(Me.GetType(), "alert", "alert('" & message & "');", True)
    End Sub
End Class
